"""\
This file is an installation script for CMFPlone (ZPT skins).  It's meant
to be used as an External Method.  To use, add an external method to the
root of the CMF Site that you want ZPT skins registered in with the
configuration:

 id: install_plone
 title: Install Decor Skins *optional*
 module name: CMFPlone.Install
 function name: install

Then go to the management screen for the newly added external method
and click the 'Try it' tab.  The install function will execute and give
information about the steps it took to register and install the
ZPT skins into the CMF Site instance. 
"""

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone import cmfplone_globals

from Acquisition import aq_base
from cStringIO import StringIO
import string
import string 

def install(self):
    " Register the Plone Skins with portal_skins and friends "
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')

    addDirectoryViews( skinstool, 'skins', cmfplone_globals )
    out.write( "Added CMFPlone directory views to portal_skins\n" )

    #
    #   Add a new skin, 'Plone', copying 'ZPT', if it exists, and then
    #   add our directories only to it.
    #
    if skinstool.getSkinPath( 'Plone' ) is None:
        #path = skinstool.getSkinPath( skinstool.getDefaultSkin() )
        path = ''
        try:
            path = skinstool.getSkinPath( 'ZPT' )
        except:
            path = skinstool.getSkinPath( 'Basic' ) #new CMF that doesnt use CMFDecor

        path = map( string.strip, string.split( path,',' ) )
        for plonedir in ( 'plone_content'
                      , 'plone_custom'
                      , 'plone_images'
                      , 'plone_forms'
                      , 'plone_scripts'
                      , 'plone_styles'
                      , 'plone_templates'
                      ):
            try:
                path.insert( path.index( 'custom')+1, plonedir )
            except ValueError:
                path.append( plonedir )
                    
        path = string.join( path, ', ' )
        skinstool.addSkinSelection( 'Plone', path )
        out.write( "Added Plone skin\n" )
    
    else:
        out.write( "Plone skin already exists\n" )

    return out.getvalue()


